---
title: Upload Files to the SurveyJS Storage
product: Form Library
description: SurveyJS Creator comes with a free full-scale demo for JavaScript and Azure storage that you can use to save your test forms. Have a try to make sure it has all you need, including the file upload question type that lets respondents attach a file in a required format to prove their response or as an answer to a certain question.
framework: jQuery
source: https://surveyjs.io/form-library/examples/how-to-use-file-upload-question-in-survey-tool/jquery
index: https://surveyjs.io/form-library/examples/overview.md
---

# Upload Files to the SurveyJS Storage (jQuery)

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import $ from "jquery";
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function detectIEOrEdge() {
    var ua = window.navigator.userAgent;
    var msie = ua.indexOf("MSIE ");
    var trident = ua.indexOf("Trident/");
    var edge = ua.indexOf("Edge/");
    return edge > 0 || trident > 0 || msie > 0;
}
const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey
    .onClearFiles
    .add(function (survey, options) {
        // Code to remove files stored on your service
        // SurveyJS Service doesn't allow to remove files
        options.callback("success");
    });

// survey
//     .onUploadFiles
//     .add((survey, options) => {
//         var formData = new FormData();
//         options
//             .files
//             .forEach(function (file) {
//                 formData.append(file.name, file);
//             });
//         var xhr = new XMLHttpRequest();
//         xhr.responseType = "json";
//         xhr.open("POST", "https://api.surveyjs.io/private/Surveys/uploadFiles?accessKey=<YOUR ACCESS KEY from the https://surveyjs.io/Help/Index?apiType=private>");
//         xhr.onload = function () {
//             var data = xhr.response;
//             options.callback("success", options.files.map(file => {
//                 return {
//                     file: file,
//                     content: data[file.name]
//                 };
//             }));
//         };
//         xhr.send(formData);
//     });

// survey
//     .onDownloadFile
//     .add((survey, options) => {
//         var xhr = new XMLHttpRequest();
//         xhr.responseType = "blob";
//         xhr.open("GET", "https://api.surveyjs.io/private/Surveys/files?name=" + options.content);
//         xhr.onload = function () {
//             var reader = new FileReader();
//             reader.onload = function (e) {
//                 options.callback("success", e.target.result);
//             };
//             reader.readAsDataURL(new File([xhr.response], options.fileValue.name, {type: options.fileValue.type}));
//         };
//         xhr.send();
//     });

survey.onUploadFiles.add(function (survey, options) {
    options.files.forEach(file => {
        var formData = new FormData();
        formData.append('postId', 'cbd4f8b2-f9df-4eb0-99f7-2dcc61a41d03');
        formData.append("file", file);
        var xhr = new XMLHttpRequest();
        xhr.responseType = "json";
        xhr.open("POST", "https://api.surveyjs.io/public/v1/Survey/upload/");
        xhr.onload = () => {
            if (xhr.readyState === xhr.DONE) {
                if (xhr.status === 200) {
                    const data = xhr.response;
                    var content = data.replace('dxsfile:', 'https://api.surveyjs.io/public/v1/Survey/file?filePath=');
                    if (data.indexOf("dxsimage:") === 0) {
                        content = data.replace('dxsimage:', 'https://api.surveyjs.io/public/v1/Survey/file?filePath=');
                    }
                    options.callback("success", [{
                        file: file,
                        content: content
                    }]);
                }
            }
        };
        xhr.send(formData);
    });
});


survey.onDownloadFile.add((survey, options) => {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", options.content);
    xhr.onloadstart = function (ev) {
        xhr.responseType = "blob";
    }
    xhr.onload = () => {
        var file;
        if (detectIEOrEdge()) {
            file = new Blob([xhr.response], options.fileValue.name, { type: options.fileValue.type });
        }
        else {
            file = new File([xhr.response], options.fileValue.name, { type: options.fileValue.type });
        }
        var reader = new FileReader();
        reader.onload = function (e) {
            options.callback("success", e.target.result);
        };
        reader.readAsDataURL(file);
    };
    xhr.send();
});


$("#surveyElement").Survey({ model: survey });
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "file",
      "title": "Please upload your files",
      "name": "files",
      "storeDataAsText": false,
      "allowMultiple": true,
      "maxSize": 102400
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "jquery": "latest",
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/how-to-use-file-upload-question-in-survey-tool/angular.md)
- [React](https://surveyjs.io/form-library/examples/how-to-use-file-upload-question-in-survey-tool/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/how-to-use-file-upload-question-in-survey-tool/vue3js.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/how-to-use-file-upload-question-in-survey-tool/vanillajs.md)


---
title: Upload Files to the SurveyJS Storage
product: Form Library
description: SurveyJS Creator comes with a free full-scale demo for JavaScript and Azure storage that you can use to save your test forms. Have a try to make sure it has all you need, including the file upload question type that lets respondents attach a file in a required format to prove their response or as an answer to a certain question.
framework: React
source: https://surveyjs.io/form-library/examples/how-to-use-file-upload-question-in-survey-tool/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Upload Files to the SurveyJS Storage (React)

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function detectIEOrEdge() {
    var ua = window.navigator.userAgent;
    var msie = ua.indexOf("MSIE ");
    var trident = ua.indexOf("Trident/");
    var edge = ua.indexOf("Edge/");
    return edge > 0 || trident > 0 || msie > 0;
}
function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey
        .onClearFiles
        .add(function (survey, options) {
            // Code to remove files stored on your service
            // SurveyJS Service doesn't allow to remove files
            options.callback("success");
        });
    
    // survey
    //     .onUploadFiles
    //     .add((survey, options) => {
    //         var formData = new FormData();
    //         options
    //             .files
    //             .forEach(function (file) {
    //                 formData.append(file.name, file);
    //             });
    //         var xhr = new XMLHttpRequest();
    //         xhr.responseType = "json";
    //         xhr.open("POST", "https://api.surveyjs.io/private/Surveys/uploadFiles?accessKey=<YOUR ACCESS KEY from the https://surveyjs.io/Help/Index?apiType=private>");
    //         xhr.onload = function () {
    //             var data = xhr.response;
    //             options.callback("success", options.files.map(file => {
    //                 return {
    //                     file: file,
    //                     content: data[file.name]
    //                 };
    //             }));
    //         };
    //         xhr.send(formData);
    //     });
    
    // survey
    //     .onDownloadFile
    //     .add((survey, options) => {
    //         var xhr = new XMLHttpRequest();
    //         xhr.responseType = "blob";
    //         xhr.open("GET", "https://api.surveyjs.io/private/Surveys/files?name=" + options.content);
    //         xhr.onload = function () {
    //             var reader = new FileReader();
    //             reader.onload = function (e) {
    //                 options.callback("success", e.target.result);
    //             };
    //             reader.readAsDataURL(new File([xhr.response], options.fileValue.name, {type: options.fileValue.type}));
    //         };
    //         xhr.send();
    //     });
    
    survey.onUploadFiles.add(function (survey, options) {
        options.files.forEach(file => {
            var formData = new FormData();
            formData.append('postId', 'cbd4f8b2-f9df-4eb0-99f7-2dcc61a41d03');
            formData.append("file", file);
            var xhr = new XMLHttpRequest();
            xhr.responseType = "json";
            xhr.open("POST", "https://api.surveyjs.io/public/v1/Survey/upload/");
            xhr.onload = () => {
                if (xhr.readyState === xhr.DONE) {
                    if (xhr.status === 200) {
                        const data = xhr.response;
                        var content = data.replace('dxsfile:', 'https://api.surveyjs.io/public/v1/Survey/file?filePath=');
                        if (data.indexOf("dxsimage:") === 0) {
                            content = data.replace('dxsimage:', 'https://api.surveyjs.io/public/v1/Survey/file?filePath=');
                        }
                        options.callback("success", [{
                            file: file,
                            content: content
                        }]);
                    }
                }
            };
            xhr.send(formData);
        });
    });
    
    
    survey.onDownloadFile.add((survey, options) => {
        var xhr = new XMLHttpRequest();
        xhr.open("GET", options.content);
        xhr.onloadstart = function (ev) {
            xhr.responseType = "blob";
        }
        xhr.onload = () => {
            var file;
            if (detectIEOrEdge()) {
                file = new Blob([xhr.response], options.fileValue.name, { type: options.fileValue.type });
            }
            else {
                file = new File([xhr.response], options.fileValue.name, { type: options.fileValue.type });
            }
            var reader = new FileReader();
            reader.onload = function (e) {
                options.callback("success", e.target.result);
            };
            reader.readAsDataURL(file);
        };
        xhr.send();
    });
    
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "file",
      "title": "Please upload your files",
      "name": "files",
      "storeDataAsText": false,
      "allowMultiple": true,
      "maxSize": 102400
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/how-to-use-file-upload-question-in-survey-tool/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/how-to-use-file-upload-question-in-survey-tool/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/how-to-use-file-upload-question-in-survey-tool/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/how-to-use-file-upload-question-in-survey-tool/vanillajs.md)
